#ifndef _CTR_MEMORY_H_
#define _CTR_MEMORY_H_

#include <nn.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Function definitions */
int  CTR_MEM_Init( void );
void CTR_MEM_Term( void );
void *CTR_MEM_Malloc( size_t size );
void *CTR_MEM_Malloc32( size_t size );
void *CTR_MEM_MallocEx( size_t size, int alignment );
void CTR_MEM_Free( void *ptr );
void *CTR_MEMSET( void* s, int c, size_t n );
void CTR_MEMCPY( void* dst, const void* src, size_t size );
int CTR_MEMCMP( const void* mem1, const void* mem2, size_t size );
unsigned long CTR_MEM_GetFreeSizeOfHeap( void );

#ifdef __cplusplus
}
#endif

#endif /* #ifndef _CTR_MEMORY_H_ */
