/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     demo_ProgramObject.h

  Copyright (C)2009-2013 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 50863 $
 *---------------------------------------------------------------------------*/

#ifndef DEMO_PROGRAM_OBJECT_H_
#define DEMO_PROGRAM_OBJECT_H_

#include <nn/gx.h>
#include <nn/math.h>

#include "demo/Utility/demo_Utility.h"
#include "demo/RenderData/demo_TrianglesRenderData.h"

namespace demo
{ 
    
    /* Please see man pages for details 
    

    
    */
    const u32 PROGRAM_OBJECT_MAX_SHADERS = 1;
     
    /* Please see man pages for details 
    

    
    */

    class ProgramObject : private nn::util::NonCopyable<ProgramObject>
    {
    public:
        /* Please see man pages for details 
        

        
        */
        ProgramObject(void);

        /* Please see man pages for details 
        

        
        */
        virtual ~ProgramObject(void);

    public:        
        /* Please see man pages for details 
        

        
        */        
        virtual bool Initialize(const GLuint shaderId) = 0;

        /* Please see man pages for details 
        

        
        */
        virtual bool Finalize(void) = 0;

    public:
        /* Please see man pages for details 
        

        
        */
        virtual bool Begin(void);

        /* Please see man pages for details 
        

        
        */
        virtual bool Use(void) = 0;

        /* Please see man pages for details 
        

        
        */
        virtual bool End(void);

    public:
        /* Please see man pages for details 
        

        
        
        
        */
        virtual u32 GetVertexAttributes(void);
        
        /* Please see man pages for details 
        

        
        
        
        */        
        virtual void SetUse3d(const bool use3d);

        /* Please see man pages for details 
        

        
                
        
        */
        virtual void SetProjectionMatrix(const nn::math::MTX44& projectionMatrix);
        
        /* Please see man pages for details 
        

        
        
        
        */        
        virtual void SetModelViewMatrix(const nn::math::MTX44& modelViewMatrix);

        /* Please see man pages for details 
        

        
        
        
        */
        virtual void SetTextureId(const GLuint textureId);

        /* Please see man pages for details 
        

        
        */
        virtual void Update(void);

    protected:
        virtual void InitializeVertexAttributes(void);
        virtual void InitializeUniforms(void);
        virtual void UpdateModelViewProjectionMatrix(void);
    
    protected:
        bool m_Initialized;
        bool m_Padding0[3];

        u32 m_VertexAttributes;
        bool m_Use3d;
        u8 m_Padding[3];
        
        GLuint m_ProgramId;
        GLuint m_ShaderIds[PROGRAM_OBJECT_MAX_SHADERS];
        GLint m_UniformLocation[MAX_UNIFORM_LOCATIONS_NUM];

        nn::math::MTX44 m_ProjectionMatrix;
        nn::math::MTX44 m_ModelViewMatrix;
    };

}

#endif
